import { TypedPathParam } from './_BasePath';
import { BaseNodeType } from '../nodes/_Base';
import { ParamType } from '../poly/ParamType';
import { ParamValuesTypeMap } from './types/ParamValuesTypeMap';
import { ParamInitValuesTypeMap } from './types/ParamInitValuesTypeMap';
export declare class NodePathParam extends TypedPathParam<ParamType.NODE_PATH> {
    static type(): ParamType;
    initialize_param(): void;
    get default_value_serialized(): string;
    get raw_input_serialized(): string;
    get value_serialized(): string;
    protected _copy_value(param: NodePathParam): void;
    static are_raw_input_equal(raw_input1: ParamInitValuesTypeMap[ParamType.NODE_PATH], raw_input2: ParamInitValuesTypeMap[ParamType.NODE_PATH]): boolean;
    static are_values_equal(val1: ParamValuesTypeMap[ParamType.NODE_PATH], val2: ParamValuesTypeMap[ParamType.NODE_PATH]): boolean;
    get is_default(): boolean;
    setNode(node: BaseNodeType): void;
    protected process_raw_input(): void;
    protected process_computation(): Promise<void>;
    private find_target;
    private _assign_found_node;
    private _expected_context;
    private _is_node_expected_context;
    private _expected_node_types;
    private _is_node_expected_type;
    notify_path_rebuild_required(node: BaseNodeType): void;
    notify_target_param_owner_params_updated(node: BaseNodeType): void;
}
